#ifndef MainH
#define MainH

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
#include <ImgList.hpp>
#include <ExtCtrls.hpp>
#include <IniFiles.hpp>
#include <Dialogs.hpp>
#include "ThemeMgr.hpp"

#include "Commands.h"
#include "FloatEdit.hpp"

//---------------------------------------------------------------------------

class TMainForm : public TForm
{
__published:	// IDE-managed Components
  TStatusBar *StatusBar;
  TMainMenu *MainMenu1;
  TMenuItem *mnFille;
  TMenuItem *mnHelp;
  TMenuItem *mnControl;
  TMenuItem *mnLock;
  TMenuItem *mnMute;
  TMenuItem *N1;
  TMenuItem *mnRecall;
  TMenuItem *mnReload;
  TMenuItem *mnOpen;
  TMenuItem *mnSaveAs;
  TMenuItem *N2;
  TMenuItem *mnExit;
  TMenuItem *mnAbout;
  TOpenDialog *OpenDialog;
  TSaveDialog *SaveDialog;
  TTimer *Timer1;
  TMenuItem *N3;
  TMenuItem *mnReview;
  TGroupBox *GroupBox1;
  TLabel *Label4;
  TLabel *Label5;
  TLabel *Label6;
  TLabel *lbLevelA;
  TLabel *lbAa;
  TLabel *Label13;
  TLabel *Label14;
  TFloatEdit *feFa;
  TFloatEdit *fePa;
  TFloatEdit *feAa;
  TComboBox *cbMa;
  TComboBox *cbSa;
  TLabel *Label33;
  TComboBox *cbRa;
  TMenuItem *N4;
  TMenuItem *Settings;
  TMenuItem *Autorecall;
  TMenuItem *Autoreload;
  TMenuItem *N5;
  TGroupBox *GroupBox3;
  TComboBox *cbPre;
  TButton *btRead;
  TButton *btSave;
  TThemeManager *ThemeManager1;
  TGroupBox *GroupBox2;
  TLabel *Label1;
  TLabel *Label2;
  TLabel *Label3;
  TLabel *lbLevelB;
  TLabel *lbAb;
  TLabel *Label9;
  TLabel *Label11;
  TLabel *Label15;
  TFloatEdit *feFb;
  TFloatEdit *fePb;
  TFloatEdit *feAb;
  TComboBox *cbMb;
  TComboBox *cbSb;
  TComboBox *cbRb;
  TMenuItem *N6;
  TMenuItem *mnRmsA;
  TMenuItem *mnRmsB;
  void __fastcall FormCreate(TObject *Sender);
  void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
  void __fastcall mnOpenClick(TObject *Sender);
  void __fastcall mnSaveAsClick(TObject *Sender);
  void __fastcall mnExitClick(TObject *Sender);
  void __fastcall mnLockClick(TObject *Sender);
  void __fastcall mnRecallClick(TObject *Sender);
  void __fastcall mnReloadClick(TObject *Sender);
  void __fastcall feWaChanged(TObject *Sender);
  void __fastcall cbMaChange(TObject *Sender);
  void __fastcall Timer1Timer(TObject *Sender);
  void __fastcall mnReviewClick(TObject *Sender);
  void __fastcall mnAboutClick(TObject *Sender);
  void __fastcall SettingsClick(TObject *Sender);
  void __fastcall btSaveClick(TObject *Sender);
  void __fastcall btReadClick(TObject *Sender);
  void __fastcall feWaEnter(TObject *Sender);
  void __fastcall cbMaEnter(TObject *Sender);
  void __fastcall mnRmsAClick(TObject *Sender);
private:	// User declarations
  bool FConnected;
  bool FLock;
  bool Lock;
  int ValOuts[OUTS][POUTS_MAX]; //OUTS array
  void __fastcall ReadConfig(void);
  void __fastcall SaveConfig(void);
  void __fastcall ReadData(AnsiString FileName);
  void __fastcall SaveData(AnsiString FileName);
  void __fastcall DoEdit(TObject *Sender, int &ch, int &par, double &val);
  void __fastcall DoCombo(TObject *Sender, int &ch, int &par, int &val);
  void __fastcall ShowAll(void);
  int __fastcall  Val2Par(double v);
  void __fastcall Reload(void);
  void __fastcall Recall(void);
public:		// User declarations
  __fastcall TMainForm(TComponent* Owner);
  bool Mute;
};

//---------------------------------------------------------------------------

extern PACKAGE TMainForm *MainForm;

//---------------------------------------------------------------------------

#endif
